1000 REMark     --------------------------------------------------------
1010 REMark                        softEPROM v1.10
1020 REMark          Relocates EPROMs to files for the Sinclair QL
1030 REMark     --------------------------------------------------------
1040 REMark                Last update is 4th August 1991
1050 REMark             developped on Minerva v1.79 by QView
1060 REMark        compiled with Turbo v2.04 by Digital Precision
1070 REMark         !!! NOT GUARANTEED TO CONVERT ALL EPROMS !!!
1080 REMark     --------------------------------------------------------
1090 REMark                       Emmanuel VERBEECK
1100 REMark                      142, Try des Marais
1110 REMark                    5651 TARCIENNE (BELGIUM)
1120 REMark                       Tel: 071-21.36.36
1130 REMark     --------------------------------------------------------
1140 :
1150 REMark directives de compilation pour Turbo v2.04
1160 REMark display Nos; Structured; REMs; <64K; 0 windows; dataspace 1K
1170 DATA_AREA 1
1180 :
1190 REMark declaration des chaines de caracteres
1200 DIM titre$(40), code$(40), chargeur$(40)
1210 :
1220 REMark declaration des constantes
1230 LET reset_adr = 386
1240 IF 'JSL' INSTR VER$ THEN LET reset_adr = 390
1250 LET relocated_length = 16384 + 12
1260 LET eprom_length = 16384
1270 LET code_length = 12
1280 LET eprom_base = 49152
1290 LET sys_base = 163840
1300 IF PEEK_W(sys_base) <> -11692 THEN LET sys_base = 196608
1310 :
1320 REMark traitement asynchrone des erreurs d'E/S
1330 WHEN_ERROR 0
1340   LET erreur% = 1
1350   RETRY
1360 END_WHEN
1370 :
1380 REMark panneau de bienvenue
1390 IF PEEK(sys_base + 52) THEN MODE 4
1400 OPEN #1,"con_360x200a76x28"
1410 PAPER 4
1420 CLS
1430 BORDER 2,7,2
1440 CSIZE 1,0
1450 INK 2
1460 AT 3,5: PRINT "Relocate hardware EPROM cartridges";
1470 AT 5,19: PRINT "with";
1480 INK 7
1490 CSIZE 2,1
1500 OVER 1
1510 LET titre$ = "SOFTEPROM"
1520 IF titre$(5) <> "E" THEN CALL reset_adr
1530 CURSOR 114,80: PRINT titre$;
1540 CURSOR 115,81: PRINT titre$;
1550 OVER -1
1560 CURSOR 114,80: PRINT titre$;
1570 CURSOR 115,81: PRINT titre$;
1580 CSIZE 1,0
1590 LET titre$ = "version 1.10, August 1991"
1600 IF titre$(11 TO 12) <> 10 THEN CALL reset_adr
1610 AT 12,9: PRINT titre$;
1620 CSIZE 2,1
1630 OVER 1
1640 LET titre$ = "by Emmanuel Verbeeck"
1650 IF CODE(titre$(7)) <> CODE(titre$(16)) - 1 THEN CALL reset_adr
1660 INK 7
1670 CURSOR 53,161: PRINT titre$;
1680 INK 4
1690 CURSOR 52,160: PRINT titre$;
1700 :
1710 REMark attente de la fin de la lecture
1720 CSIZE 2,0
1730 INK 7
1740 CURSOR 330,180
1750 PAN 0,115
1760 LET touche% =  CODE(INKEY$(#1,-1))
1770 OVER 0
1780 PAN 0,116
1790 :
1800 REMark y a-t'il un EPROM connectee ?
1810 IF PEEK_W(eprom_base) <> 19195 OR PEEK_W(eprom_base + 2) <> 1 THEN
1820   STRIP 7
1830   INK 0
1840   AT 14,5: PRINT "  NO EPROM FITTED  "
1850   CLOSE #1
1860   STOP
1870 END IF
1880 CLOSE #1
1890 :
1900 REMark fenetre principale
1910 OPEN #1,"con_346x130a76x68"
1920 PAPER 4
1930 CLS
1940 INK 2
1950 CLS
1960 BORDER 2,7,2
1970 AT 2,3: PRINT "Output filename (_bin)";
1980 AT 7,3: PRINT "Loader filename (_bas)";
1990 :
2000 REMark fenetres des fichiers de sortie
2010 OPEN #3,"con_264x12a116x110"
2020 PAPER #3,7
2030 BORDER #3,1,0,7
2040 CLS #3
2050 INK #3,0
2060 CSIZE #3,1,0
2070 :
2080 OPEN #4,"con_264x12a116x160"
2090 PAPER #4,7
2100 BORDER #4,1,0,7
2110 CLS #4
2120 INK #4,0
2130 CSIZE #4,1,0
2140 :
2150 REMark lecture du nom du fichier binaire
2160 RETRY_HERE
2170 REPeat lecture%
2180   LET erreur% = 0
2190   CLS #3
2200   INPUT #3,code$;
2210   IF code$ = "" THEN
2220     CLOSE #3
2230     CLOSE #4
2240     CLOSE #1
2250     STOP
2260   END IF
2270   IF NOT code$(LEN(code$) - 3 TO) == "_bin" THEN
2280     LET code$ = code$ & "_bin"
2290   END IF
2300   DELETE code$
2310   OPEN_NEW #5,code$
2320   IF NOT(erreur%) THEN EXIT lecture%
2330 END REPeat lecture%
2340 CLOSE #5
2350 CLS #3
2360 PRINT #3,code$;
2370 :
2380 REMark lecture du nom de fichier en basic
2390 RETRY_HERE
2400 REPeat lecture%
2410   LET erreur% = 0
2420   CLS #4
2430   INPUT #4,chargeur$;
2440   IF chargeur$ = "" THEN
2450     CLOSE #3
2460     CLOSE #4
2470     CLOSE #1
2480     STOP
2490   END IF
2500   IF NOT(chargeur$(LEN(chargeur$) - 3 TO) == "boot") THEN
2510     IF NOT chargeur$(LEN(chargeur$) - 3 TO) == "_bas"
2520       LET chargeur$ = chargeur$ & "_bas"
2530     END IF
2540   END IF
2550   DELETE chargeur$
2560   OPEN_NEW #5,chargeur$
2570   IF NOT(erreur%) THEN EXIT lecture%
2580 END REPeat lecture%
2590 CLOSE #5
2600 CLS #4
2610 PRINT #4,chargeur$;
2620 :
2630 REMark creation du fichier binaire
2640 LET adresse = RESPR(relocated_length)
2650 MOVE_MEMORY eprom_length, eprom_base TO adresse + 12
2660 :
2670 LET procedures = PEEK_W(eprom_base + 4) + 10
2680 LET initialisation = PEEK_W(eprom_base + 6) + 12
2690 :
2700 POKE_W adresse, 17402
2710 POKE_W adresse + 2, procedures
2720 POKE_W adresse + 4, 13432
2730 POKE_W adresse + 6, 272
2740 POKE_W adresse + 8, 20114
2750 POKE_W adresse + 10, 20085
2760 :
2770 DELETE code$
2780 LET erreur% = 0
2790 SBYTES code$,adresse,relocated_length
2800 :
2810 REMark creation du fichier basic
2820 DELETE chargeur$
2830 OPEN_NEW #5,chargeur$
2840 PRINT #5,'10 REMark loader generated by SoftEPROM v1.10 by E.Verbeeck'
2850 PRINT #5,'20 LET adr = RESPR('; (eprom_length + code_length); ')'
2860 PRINT #5,'30 LBYTES "'; code$; '", adr'
2870 IF procedures <> 10 THEN
2880   PRINT #5,'40 CALL adr'
2890 END IF
2900 IF initialisation <> 12 THEN
2910   PRINT #5,'50 CALL adr + '; initialisation
2920 END IF
2930 CLOSE #5
2940 :
2950 CLS
2960 AT 6,4: PRINT "Job done flawlessly."
2970 CLOSE #3
2980 CLOSE #4
2990 CLOSE #1
3000 STOP
3010 :
3020 REMark end of source
